package com.shcd.service.impl;

import cn.hutool.http.HttpUtil;
import com.shcd.conf.DMConfiguration;
import com.shcd.mapper.EmailSupervisionMapper;
import com.shcd.service.EmailSupervisionService;
import com.shcd.util.EmailUtil;
import com.shcd.vo.Result;
import com.shcd.vo.Rule;
import com.shcd.vo.RuleUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class EmailSupervisionServiceImpl implements EmailSupervisionService {
    @Resource
    private EmailSupervisionMapper emailSupervisionMapper;

    @Autowired
    private EmailUtil emailUtil;

    @Autowired
    private DMConfiguration configuration;

    @Override
    public void sendEmail() {
        //获取所有的规则，用来判断是否发送邮件
        List<Rule> rules = emailSupervisionMapper.getAllRule();
        List<Result> ruleResults = new ArrayList<>();
        Date date = new Date();
        for (Rule rule : rules) {
            Map<String, Date> time = configuration.ExcuateSql(rule.getRuleSql());
            if (time == null) {
                continue;
            }
            String s = time.keySet().toArray()[0].toString();
            //超过一小时无数据则发送邮件
            //System.out.println(time.get(s));
            if ((date.getTime() - time.get(s).getTime()) > 60 * 60 * 1000) {
                Result result = new Result();
                result.setId(rule.getId());
                result.setKeyTime(s);
                result.setTime(time.get(s).toString());
                ruleResults.add(result);
            }
        }
        List<RuleUser> users = emailSupervisionMapper.getAllUser();
        Map<Integer, List<RuleUser>> collect = users.stream().collect(Collectors.groupingBy(RuleUser::getId));
        for (Result ruleResult : ruleResults) {
            List<RuleUser> ruleUsers = collect.get(ruleResult.getId());
            for (RuleUser ruleUser : ruleUsers) {
                String s = ruleUser.getMessage().replaceAll(ruleResult.getKeyTime(), ruleResult.getTime());
                String content = ruleUser.getUsername() + ": \n" + s;
                //HttpUtil.createPost(url).form("to",ruleUser.getEmail()).form("subject",ruleUser.getSubject()).form("content",content).setReadTimeout(30000).execute();
                emailUtil.sendMail(ruleUser.getEmail(),ruleUser.getSubject(),content);
            }
        }
    }
}
